/*
NAME: 
DESCRIPTION: 模板;
PARAMETER:
	[
		{
			name : 'step',
			title : 'step',
			type : 'LineEdit',
			property : {tool_tip : '目标step,默认是orig'}
		},
		{
			name : 'auto_save',
			title : '自动保存',
			type : 'RadioBox',
			property : {
				item_list:[
					{name:'yes',text:'YES'},
					{name:'no',text:'NO'},
				],
				tool_tip:'是否自动保存料号开关'
			}
		}
	]
	
 VERSION_HISTORY:
	V1.00 2021-04-08 template
		1.新版本
		
 HELP:
	  <html><body bgcolor="#DDECFE">
		<font size="3" color="#003DB2"><p>功能简介</p></font>
		<p> template </ p>
		<br>
		<font size="3" color="#003DB2"><p>参数配置</p></font>
		<p> 模板 </p>
		<br>
		<font size="3" color="#003DB2"><p>注意事项</p></font>
		<p> 无 </p>
		<br>
	</body></html>	
*/

// 引入模块 包 外部参数
var $ = require('topcam.scriptfunc').argv();
var fs = require('fs');
var _ = require('lodash');
var mode = $.ikm ? "topcam" : "aimdfm";
var IKM = $.ikm ? $.ikm : require('topcam.ikm6')($);
var GEN = $.gen;
var Job = $.job || $.job_name;
var JobId = $.job_id;
var db = $.db || IKM.db;
var plugin = require('topsin.gengui');
var GUI = plugin.newGui(plugin.__dirname);
var PAR = {};
if ($.par) {
	PAR = $.par;
} else if ($.hasOwnProperty('script_parameter')) {
	PAR = JSON.parse($.script_parameter);
}
if (mode === "aimdfm") {
	IKM.crud("updateRow", {
		table: "pdm_aimdfm_task",
		data: { current_process_title: $.process_title },
		where: { id: $.task_id }
	});
}
var Status = 'ok';
var resultData = [];
var par = PAR; // 接收参数
var default_par = { // 设置默认参数
	step: "unit",
	auto_save: "No",
	units: "mm"
};
for (var key in default_par) {
	if (!par.hasOwnProperty(key) || par[key] == "") {
		par[key] = default_par[key];
	}
}

// 定义变量
var job = Job.toLowerCase();
require("topsin.genmath");
var genMath = new GenMath();
try {
	// 常规验证 准备工作
	if (!GEN.isJobExists({ job: job })) { throw "料号" + job + "不存在" }
	if (!GEN.isJobOpen({ job: job })) { GEN.openJob({ job: job }) }
	if (mode == "aimdfm") {
		if (GEN.checkInout({job: job,mode: "test"}) != 0) {
			throw "the job check"
		}
		GEN.checkInout({job: job,mode: "out"});
	}
	// 主体
	var stepList = GEN.getStepList({ job: job });
	stepList = stepList.filter(function (v) {
		var tmpreg = new RegExp(par.step, "ig");
		return tmpreg.test(v);
	});
	if (stepList.length == 0) {
		throw "未找到" + par.step
	}

	stepList.forEach(function (step) {
		GEN.openStep({ job: job, name: step });
		GEN.clearLayers();  //清除层显示
		GEN.affectedLayer({ mode: 'all', affected: 'no' }); //设置影响层全部不影响
		GEN.COM("sel_options,clear_mode=clear_after,display_mode=all_layers,area_inout=inside,area_select=select,select_mode=standard,area_touching_mode=exclude");
		GEN.units({ type: par.units }); //单位初始化
		GEN.zoomHome();  //窗口显示回到原始位置
		GEN.selClearFeature()
	



		




		GEN.affectedLayer({ mode: 'all', affected: 'no' }); //设置影响层全部不影响
		GEN.clearLayers();  //清除层显示
	});

	// 保存料号
	if (/yes/ig.test(par.auto_save)) {
		GEN.checkInout({ job: job, mode: "out" });
		GEN.saveJob({ job: job });
		GEN.checkInout({ job: job, mode: "in" });
	}

	// 结尾返回  固定写法
	var Return = "Done";
	if (mode === "aimdfm") {
		IKM.crud("updateRow", {
			table: "pdm_aimdfm_task",
			data: { progress: 100 },
			where: { id: $.task_id }
		});
		var tmperr = { type: "info", title: "操作完成, 请注意检查!" };
		if (GEN.hasError()) {
			Status = 'error';
			tmperr = { type: "error", title: "GEN错误!", detail: [{ desc: GEN.STATUS.join("\n") }] };
		}
		resultData.push(tmperr);
		Return = { status: Status, result_data: resultData };
	}
	return Return;
} catch (e) {
	var showGUI = true;
	if (GEN.STATUS.length > 0) {
		if (GEN.STATUS.indexOf("Pause Exit:0") >= 0) {
			showGUI = false;
		}
		e = _.toString(e) + "\n" + GEN.STATUS.join("\n");
	}
	if (showGUI) {
		IKM.msg(e);
	}
	Status = 'error';
	resultData.push({ type: "error", title: "脚本执行出错!", detail: [{ desc: _.toString(e) }] });
	return mode === "aimdfm" ? { status: Status, result_data: resultData } : "Error";
}

/**
 * 获取层别
 * @param {Object} 过滤选项
 * @returns {Array}
 */
function getLayer(props) {
	if (!props) {
		props = {};
	}
	var matrix = GEN.getMatrix({ job: job });
	return Object.keys(matrix).reduce(function (a, b) {
		var info = matrix[b];
		var ret = true;
		for (var _key in props) {
			if (info[_key]) {
				if (/object string|object number/ig.test({}.toString.call(props[_key]))) {
					if (props[_key] != info[_key]) {
						ret = false;
					}
				}
				if (/object RegExp/ig.test({}.toString.call(props[_key]))) {
					if (!props[_key].test(info[_key])) {
						ret = false;
					}
				}
				if (/object function/ig.test({}.toString.call(props[_key]))) {
					if (!props[_key](info[_key])) {
						ret = false;
					}
				}
			}
		}
		if (ret) {
			a.push(props.res == "info" ? info : b);
		}
		return a;
	}, []);
}



// 连接位修复
function check_connect_line_and_connnect(props){
    GEN.COM("disp_off");
    GEN.affectedLayer({affected:'yes',layer:props.layer,clear_before:'yes'});
    GEN.flattenLayer({source_layer:props.layer,target_layer:props.layer+'++tl++tmp++'});
//	GEN.selCopyOther(target_layer:$par{layer}.'++tl++tmp++',invert:'no');
    GEN.affectedLayer(affected:'yes',layer:$par{layer}.'++tl++tmp++',clear_before:'yes');//当前工作层
	//1.去重复和cover 
	my $check_list = 'topcam_tl_nflr_cover';
	if ( GEN.isChklistExists(job=>$Job,step=>$Step,chklist=>$check_list) ){
		GEN.COM("chklist_delete",chklist=>$check_list);
	}
	my (%params,@items);
	$params{pp_layer} = '.affected';
	$params{pp_min_line} = 0;
	$params{pp_max_line} = 100;
	$params{pp_margin} = 1;
	$params{pp_remove_item} = 'Line\;Arc';
	$params{pp_delete} = 'Covered';
	$params{pp_work} = 'Features';
	$params{pp_remove_mark} = 'Remove';
	push @items,(
					{
						name=>'tl_nflr_cover',
						nact=>1,
						action=>'valor_dfm_nflr',
						erf=>'Report All (Mils)',
						params=>\%params,
					}
	);
	GEN.createChklist(chklist=>$check_list,items=>[@items]);            
	GEN.COM('chklist_run',chklist=>$check_list,nact=>1,area=>'profile');
	
	my $check_list_ = 'topcam_tl_nflr_duplicated';
	if ( GEN.isChklistExists(job=>$Job,step=>$Step,chklist=>$check_list_) ){
		GEN.COM("chklist_delete",chklist=>$check_list_);
	}
	my (%params_,@items_);
	$params_{pp_layer} = '.affected';
	$params_{pp_min_line} = 0;
	$params_{pp_max_line} = 100;
	$params_{pp_margin} = 1;
	$params_{pp_remove_item} = 'Line\;Arc';
	$params_{pp_delete} = 'Duplicated';
	$params_{pp_work} = 'Features';
	$params_{pp_remove_mark} = 'Remove';
	push @items_,(
					{
						name=>'tl_nflr_duplicated',
						nact=>1,
						action=>'valor_dfm_nflr',
						erf=>'Report All (Mils)',
						params=>\%params_,
					}
	);
	GEN.createChklist(chklist=>$check_list_,items=>[@items_]);            
	GEN.COM('chklist_run',chklist=>$check_list_,nact=>1,area=>'profile');
	
    GEN.selBreak();
    GEN.COM( "sel_design2rout,det_tol=10,con_tol=10,rad_tol=1" );//先修复一次 10mil内
    
    my @feat = GEN.getFeatures(job=>$Job,step=>$Step,layer=>$par{layer}.'++tl++tmp++');//抽取特殊槽
    GEN.deleteLayer(job=>$Job,layer=>'tl++other++tmp++',step=>$Step) if (GEN.isLayerExists(job=>$Job,layer=>'tl++other++tmp++'));
    foreach my $tmp (@feat){
        (my $size = $tmp->{symbol}) =~ s/^r//;
        if ($size >= 31.496) {
            GEN.COM('filter_reset',filter_name=>'popup');
            GEN.selectByFilter(include_syms=>$tmp->{symbol},profile=>'all');
            GEN.COM('filter_reset',filter_name=>'popup');
            if ( GEN.getSelectCount() > 0 ){GEN.selMoveOther(target_layer=>'tl++other++tmp++',invert=>'no',dx=>0,dy=>0,size=>0);}
        }
    }
    
    GEN.selChangeSym(symbol=>'r1');
    
    GEN.COM('profile_to_rout',layer=>'tl+wai++',width=>0);
    GEN.affectedLayer(affected=>'yes',layer=>'tl+wai++',clear_before=>'yes');
    GEN.COM( "sel_cut_data,det_tol=1,con_tol=1,rad_tol=0.1,filter_overlaps=no,delete_doubles=no,use_order=yes,ignore_width=yes,ignore_holes=all,start_positive=yes,polarity_of_touching=same");
    
    GEN.affectedLayer(affected=>'yes',layer=>'tl+wai+++++',clear_before=>'yes');
    GEN.COM('sr_fill', polarity => 'positive', step_margin_x => 0, step_margin_y => 0, step_max_dist_x => 100, step_max_dist_y => 100, sr_margin_x => 0, sr_margin_y => 0, sr_max_dist_x => 0, sr_max_dist_y => 0, nest_sr => 'yes', stop_at_steps => '', consider_feat => 'no', consider_drill => 'no', consider_rout => 'no', dest => 'affected_layers', attributes => 'no');
    GEN.COM('fill_params', type => 'solid', origin_type => 'datum', solid_type => 'fill', std_type => 'line', min_brush => 1, use_arcs => 'yes', symbol => '', dx => '0.1', dy => '0.1', x_off => 0, y_off => 0, std_angle => 45, std_line_width => 10, std_step_dist => 50, std_indent => 'odd', break_partial => 'yes', cut_prims => 'no', outline_draw => 'no', outline_width => 0, outline_invert => 'no');
    GEN.COM('sel_fill');
    GEN.selContourize();
    GEN.selCopyOther(target_layer=>'tl+wai++',invert=>'yes');//单只的suface
    GEN.affectedLayer(affected=>'yes',layer=>'tl+wai++',clear_before=>'yes');
    GEN.selContourize();
    GEN.COM('sel_resize', size => -10, corner_ctl => 'no');
    GEN.COM('sel_resize', size => 20, corner_ctl => 'no');
    GEN.COM('fill_params', type => 'solid', origin_type => 'datum', solid_type => 'fill', std_type => 'line', min_brush => 1, use_arcs => 'yes', symbol => '', dx => '0.1', dy => '0.1', x_off => 0, y_off => 0, std_angle => 45, std_line_width => 10, std_step_dist => 50, std_indent => 'odd', break_partial => 'yes', cut_prims => 'no', outline_draw => 'no', outline_width => 0, outline_invert => 'no');
    GEN.COM('sel_fill');
    GEN.selContourize();
    
    
    GEN.createLayer(job=>$Job,layer=>'++profice++tmp++',context=>'misc',type=>'document',delete_exists=>'yes');
    GEN.affectedLayer(affected=>'yes',layer=>'++profice++tmp++',clear_before=>'yes');
    my $profile = GEN.getProfileLimits(job=>$Job,step=>$Step);
    GEN.addRectangle(x1=>$profile->{xmin},y1=>$profile->{ymin},x2=>$profile->{xmax},y2=>$profile->{ymax},type=>'line',symbol=>'r1');
    
    GEN.affectedLayer(affected=>'yes',layer=>$par{layer}.'++tl++tmp++',clear_before=>'yes');//工作层
    GEN.selCopyOther(target_layer=>'tl+wai+++++',invert=>'yes');
    GEN.affectedLayer(affected=>'yes',layer=>'tl+wai+++++',clear_before=>'yes');//工作层
    GEN.selContourize();
    GEN.COM('fill_params', type => 'solid', origin_type => 'datum', solid_type => 'fill', std_type => 'line', min_brush => 1, use_arcs => 'yes', symbol => '', dx => '0.1', dy => '0.1', x_off => 0, y_off => 0, std_angle => 45, std_line_width => 10, std_step_dist => 50, std_indent => 'odd', break_partial => 'yes', cut_prims => 'no', outline_draw => 'no', outline_width => 0, outline_invert => 'no');
    GEN.COM('sel_fill');
    GEN.selContourize();
    GEN.selRefFeat(layers=>'++profice++tmp++',use=>'filter',mode=>'disjoint');
    GEN.selDelete() if ( GEN.getSelectCount() > 0 );
    GEN.selRefFeat(layers=>'tl+wai++',use=>'filter',mode=>'touch');
    GEN.selDelete() if ( GEN.getSelectCount() > 0 );
    GEN.COM('sel_resize', size => 10, corner_ctl => 'no');
    GEN.selMoveOther(target_layer=>'tl+wai++',invert=>'no',dx=>0,dy=>0,size=>1);
    
    GEN.affectedLayer(affected=>'yes',layer=>$par{layer}.'++tl++tmp++',clear_before=>'yes');
    GEN.selRefFeat(layers=>'tl+wai++',use=>'filter',mode=>'cover');
    if (GEN.getSelectCount() > 0){
        GEN.selRefFeat(layers=>'tl+wai++',use=>'select',mode=>'touch');
        if (GEN.getSelectCount() > 0){
            GEN.createLayer(job=>$Job,layer=>'++tl+connect+line+',context=>'misc',type=>'document',delete_exists=>'yes');
            GEN.selMoveOther(target_layer=>'++tl+connect+line+',invert=>'no',dx=>0,dy=>0,size=>0);
        }
    }
    
    //2.检测连接点及重绘
    my @feat1 = GEN.getFeatures(job=>$Job,step=>$Step,layer=>'++tl+connect+line+');//连接层数据
    my @feat2 = GEN.getFeatures(job=>$Job,step=>$Step,layer=>$par{layer}.'++tl++tmp++');//被连接层数据
    
    //GEN.createLayer(job=>$Job,layer=>'+tmp++',context=>'misc',type=>'document',delete_exists=>'yes');//测试数据层
    
    foreach my $tmp1 (@feat1){
        my @line_tmp;
        if ($tmp1->{type} eq 'line') {
            my($line1,$line2,$line);
            $line1 = TL::GenMath->extend_line({xs=>$tmp1->{xs},ys=>$tmp1->{ys},xe=>$tmp1->{xe},ye=>$tmp1->{ye}},0.3937);//
            $line2 = TL::GenMath->extend_line({xs=>$line1->{xe},ys=>$line1->{ye},xe=>$line1->{xs},ye=>$line1->{ys}},0.3937);
            $line = {xs=>$line2->{xe},ys=>$line2->{ye},xe=>$line2->{xs},ye=>$line2->{ys}};
            
            //GEN.workLayer(name=>'+tmp++',display_number=>1,clear_before=>'yes');
            //GEN.addLine(xs=>$line->{xs},ys=>$line->{ys},xe=>$line->{xe},ye=>$line->{ye},symbol=>'r2');
            
            foreach my $tmp2 (@feat2){
                my($line_x1,$line_x2,$line_y1,$line_y2,$line2_x1,$line2_x2,$line2_y1,$line2_y2);//重新比较大小一次方便后面判断线段
                $line_x1 = $line->{xs} < $line->{xe} ? $line->{xs} : $line->{xe};
                $line_x2 = $line->{xs} < $line->{xe} ? $line->{xe} : $line->{xs};
                $line_y1 = $line->{ys} < $line->{ye} ? $line->{ys} : $line->{ye};
                $line_y2 = $line->{ys} < $line->{ye} ? $line->{ye} : $line->{ys};
                
                $line2_x1 = $tmp2->{xs} < $tmp2->{xe} ? $tmp2->{xs} : $tmp2->{xe};
                $line2_x2 = $tmp2->{xs} < $tmp2->{xe} ? $tmp2->{xe} : $tmp2->{xs};
                $line2_y1 = $tmp2->{ys} < $tmp2->{ye} ? $tmp2->{ys} : $tmp2->{ye};
                $line2_y2 = $tmp2->{ys} < $tmp2->{ye} ? $tmp2->{ye} : $tmp2->{ys};
                
                if(($line2_x1 >= $line_x1 && $line2_x2 <= $line_x2 && $line2_y1 <= $line_y1 && $line2_y2 >= $line_y2)
                    ||
                    ($line2_x1 <= $line_x1 && $line2_x2 >= $line_x2 && $line2_y1 >= $line_y1 && $line2_y2 <= $line_y2)){
                        my $dis =  TL::GenMath->line2line_dist({xs=>$tmp1->{xs},ys=>$tmp1->{ys},xe=>$tmp1->{xe},ye=>$tmp1->{ye}},
                                                               {xs=>$tmp2->{xs},ys=>$tmp2->{ys},xe=>$tmp2->{xe},ye=>$tmp2->{ye}});
                        $tmp2->{distance} = $dis;
                        push @line_tmp,$tmp2;
                }
            }
        }elsif(1 > 2){
            //判断是arc的情况
        }
        
        //计算交点坐标 先冒泡排序一次
        my @add_line;
        if (scalar(@line_tmp) > 1) {
            for(my $i = 0;$i < @line_tmp;$i++){
                for(my $k = $i + 1;$k < @line_tmp; $k++){
                    if ($line_tmp[$k]->{distance} < $line_tmp[$i]->{distance}) {
                        my $tmp;
                        $tmp = $line_tmp[$i];
                        $line_tmp[$i] = $line_tmp[$k];
                        $line_tmp[$k] = $tmp;
                    }
                }
            }
            my $i = 1;
            for(my $i=0;$i < 2;$i++){
                push @add_line,TL::GenMath->get_line_intersect({xs=>$tmp1->{xs},ys=>$tmp1->{ys},xe=>$tmp1->{xe},ye=>$tmp1->{ye}},
                                            {xs=>$line_tmp[$i]->{xs},ys=>$line_tmp[$i]->{ys},xe=>$line_tmp[$i]->{xe},ye=>$line_tmp[$i]->{ye}},1);
            }
        }
        
        //GEN.workLayer(name=>$par{layer}.'++tl++tmp++',display_number=>1,clear_before=>'yes');
        GEN.affectedLayer(affected=>'yes',layer=>$par{layer}.'++tl++tmp++',clear_before=>'no');
        GEN.addLine(xs=>$add_line[0]->{x},ys=>$add_line[0]->{y},xe=>$add_line[1]->{x},ye=>$add_line[1]->{y},symbol=>'r2',attributes=>[{attribute=>'.string',text=>'tl_rou_line'}]);
    }
    
    GEN.affectedLayer(affected=>'yes',layer=>$par{layer}.'++tl++tmp++',clear_before=>'yes');
    GEN.selChangeSym(symbol=>'r10');
    
    if (GEN.isLayerExists(job=>$Job,layer=>'tl++other++tmp++')){
        GEN.affectedLayer(affected=>'yes',layer=>'tl++other++tmp++',clear_before=>'yes');
        GEN.selMoveOther(target_layer=>$par{layer}.'++tl++tmp++',invert=>'no',dx=>0,dy=>0,size=>0);
        GEN.deleteLayer(job=>$Job,layer=>'tl++other++tmp++',step=>$Step);
    }
    
    GEN.deleteLayer(job=>$Job,layer=>['tl+wai+++++','tl+wai++','++profice++tmp++','++tl+connect+line+'],step=>$Step) if (GEN.isLayerExists(job=>$Job,layer=>'tl+wai++'));//删除临时层
	
	GEN.COM("disp_on");
	
	$GUI->msgbox(-icon=>'error',-text=>"连接位修复完成请仔细检查！");
	GEN.PAUSE('Please Check!');
}